#include<fstream>
#include<iostream>
#include <cstdlib>

//How points for correct test
int POINTS = 10;

using namespace std;

char * msg[]={"%i\nCannot open .in file.\n",
            "%i\nCannot open .out file.\n",
            "0\nAt row %i: Bad operation sign.\n",
            "0\nAt row %i: Bad lamp number.\n",
            "0\nAt row %i: Not allowed lamp for switch.\n",
            "0\nAt row %i: Lamp already is in this state.\n",
            "%i\nNot all lamps are turned on.\n"};

void prn_err(char *ch, int i){
  printf(ch,i);
  exit(1);
}

int main(int argc, char * argv[]) {
  ifstream inf,outf;
  int row=1, lamps=0, n, i, j, k;
  char op;

  inf.open(argv[1]);
  if (inf==NULL) prn_err(msg[0],0);
  inf >> n;
  inf.close();

  outf.open(argv[2]);
  if (outf==NULL) prn_err(msg[1],0);

  for (; outf>>op>>i; row++){
    if (op != '+' and op != '-') prn_err(msg[2],row);
    if (i<1 or i>n) prn_err(msg[3],row);
    j=1<<(i-1);
    //if ((lamps&(j-1))>(j>>1)) prn_err(msg[4],row);
    if ((lamps&j-1)!= j>>1) prn_err(msg[4],row);
    else lamps^=j;
    if ((lamps&j)==(op=='+'?0:j)) prn_err(msg[5],row);
  }

  outf.close();

  if ((1<<n)-1!=lamps) prn_err(msg[6],0);
  else printf("%i\nOK!\n",POINTS);
  return 0;
}
